# DataCentersApi

## DataCentersApi

All URIs are relative to *<https://api.ionos.com/cloudapi/v6>*

| Method                                                   | HTTP request                           | Description                          |
| -------------------------------------------------------- | -------------------------------------- | ------------------------------------ |
| [**datacenters\_delete**](#datacenters_delete)           | **DELETE** /datacenters/{datacenterId} | Delete data centers                  |
| [**datacenters\_find\_by\_id**](#datacenters_find_by_id) | **GET** /datacenters/{datacenterId}    | Retrieve data centers                |
| [**datacenters\_get**](#datacenters_get)                 | **GET** /datacenters                   | List your data centers               |
| [**datacenters\_patch**](#datacenters_patch)             | **PATCH** /datacenters/{datacenterId}  | Partially modify a Data Center by ID |
| [**datacenters\_post**](#datacenters_post)               | **POST** /datacenters                  | Create a Data Center                 |
| [**datacenters\_put**](#datacenters_put)                 | **PUT** /datacenters/{datacenterId}    | Modify a Data Center by ID           |

## **datacenters\_delete**

> datacenters\_delete(datacenter\_id, pretty=pretty, depth=depth, x\_contract\_number=x\_contract\_number)

Delete data centers

Delete the specified data center and all the elements it contains. This method is destructive and should be used carefully.

#### Example

```python
from __future__ import print_function
import time
import ionoscloud
from ionoscloud.rest import ApiException

# Defining the host is optional and defaults to https://api.ionos.com/cloudapi/v6
configuration = ionoscloud.Configuration(
    host = 'https://api.ionos.com/cloudapi/v6',
)

# Example of configuring HTTP Basic Authorization
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

with ionoscloud.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = ionoscloud.DataCentersApi(api_client)
    datacenter_id = 'datacenter_id_example' # str | The unique ID of the data center.
    try:
        # Delete data centers
        api_instance.datacenters_delete(datacenter_id)
    except ApiException as e:
        print('Exception when calling DataCentersApi.datacenters_delete: %s\n' % e)
```

#### Parameters

| Name                    | Type     | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                          |
| ----------------------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------ |
| **datacenter\_id**      | **str**  | The unique ID of the data center.                                                                                                                                                                                                                                                                                                                                                                                                        |                                |
| **pretty**              | **bool** | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional] \[default to True] |
| **depth**               | **int**  | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional] \[default to 0]    |
| **x\_contract\_number** | **int**  | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                    |

#### Return type

void (empty response body)

#### Authorization

Basic Authentication, Token Authentication

#### HTTP request headers

* **Content-Type**: Not defined
* **Accept**: application/json

## **datacenters\_find\_by\_id**

> Datacenter datacenters\_find\_by\_id(datacenter\_id, pretty=pretty, depth=depth, x\_contract\_number=x\_contract\_number)

Retrieve data centers

Retrieve data centers by resource ID. This value is in the response body when the data center is created, and in the list of the data centers, returned by GET.

#### Example

```python
from __future__ import print_function
import time
import ionoscloud
from ionoscloud.rest import ApiException

# Defining the host is optional and defaults to https://api.ionos.com/cloudapi/v6
configuration = ionoscloud.Configuration(
    host = 'https://api.ionos.com/cloudapi/v6',
)

# Example of configuring HTTP Basic Authorization
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

with ionoscloud.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = ionoscloud.DataCentersApi(api_client)
    datacenter_id = 'datacenter_id_example' # str | The unique ID of the data center.
    try:
        # Retrieve data centers
        api_response = api_instance.datacenters_find_by_id(datacenter_id)
        print(api_response)
    except ApiException as e:
        print('Exception when calling DataCentersApi.datacenters_find_by_id: %s\n' % e)
```

#### Parameters

| Name                    | Type     | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                          |
| ----------------------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------ |
| **datacenter\_id**      | **str**  | The unique ID of the data center.                                                                                                                                                                                                                                                                                                                                                                                                        |                                |
| **pretty**              | **bool** | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional] \[default to True] |
| **depth**               | **int**  | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional] \[default to 0]    |
| **x\_contract\_number** | **int**  | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                    |

#### Return type

[**Datacenter**](https://docs.ionos.com/sections-test/python-sdk/cloud-api-python-sdk/models/datacenter)

#### Authorization

Basic Authentication, Token Authentication

#### HTTP request headers

* **Content-Type**: Not defined
* **Accept**: application/json

## **datacenters\_get**

> Datacenters datacenters\_get(pretty=pretty, depth=depth, x\_contract\_number=x\_contract\_number, offset=offset, limit=limit)

List your data centers

List the data centers for your account. Default limit is the first 100 items; use pagination query parameters for listing more items.

#### Example

```python
from __future__ import print_function
import time
import ionoscloud
from ionoscloud.rest import ApiException

# Defining the host is optional and defaults to https://api.ionos.com/cloudapi/v6
configuration = ionoscloud.Configuration(
    host = 'https://api.ionos.com/cloudapi/v6',
)

# Example of configuring HTTP Basic Authorization
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

with ionoscloud.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = ionoscloud.DataCentersApi(api_client)
    try:
        # List your data centers
        api_response = api_instance.datacenters_get()
        print(api_response)
    except ApiException as e:
        print('Exception when calling DataCentersApi.datacenters_get: %s\n' % e)
```

#### Parameters

| Name                    | Type     | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                          |
| ----------------------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------ |
| **pretty**              | **bool** | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional] \[default to True] |
| **depth**               | **int**  | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional] \[default to 0]    |
| **x\_contract\_number** | **int**  | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                    |
| **offset**              | **int**  | The first element (from the complete list of the elements) to include in the response (used together with \<b>\<i>limit\</i>\</b> for pagination).                                                                                                                                                                                                                                                                                       | \[optional] \[default to 0]    |
| **limit**               | **int**  | The maximum number of elements to return (use together with offset for pagination).                                                                                                                                                                                                                                                                                                                                                      | \[optional] \[default to 1000] |

#### Return type

[**Datacenters**](https://docs.ionos.com/sections-test/python-sdk/cloud-api-python-sdk/models/datacenters)

#### Authorization

Basic Authentication, Token Authentication

#### HTTP request headers

* **Content-Type**: Not defined
* **Accept**: application/json

## **datacenters\_patch**

> Datacenter datacenters\_patch(datacenter\_id, datacenter, pretty=pretty, depth=depth, x\_contract\_number=x\_contract\_number)

Partially modify a Data Center by ID

Updates the properties of the specified data center, rename it, or change the description.

#### Example

```python
from __future__ import print_function
import time
import ionoscloud
from ionoscloud.rest import ApiException

# Defining the host is optional and defaults to https://api.ionos.com/cloudapi/v6
configuration = ionoscloud.Configuration(
    host = 'https://api.ionos.com/cloudapi/v6',
)

# Example of configuring HTTP Basic Authorization
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

with ionoscloud.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = ionoscloud.DataCentersApi(api_client)
    datacenter_id = 'datacenter_id_example' # str | The unique ID of the data center.
    datacenter = ionoscloud.DatacenterProperties() # DatacenterProperties | The properties of the data center to be updated.
    try:
        # Partially modify a Data Center by ID
        api_response = api_instance.datacenters_patch(datacenter_id, datacenter)
        print(api_response)
    except ApiException as e:
        print('Exception when calling DataCentersApi.datacenters_patch: %s\n' % e)
```

#### Parameters

| Name                    | Type                                                                                                                         | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                          |
| ----------------------- | ---------------------------------------------------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------ |
| **datacenter\_id**      | **str**                                                                                                                      | The unique ID of the data center.                                                                                                                                                                                                                                                                                                                                                                                                        |                                |
| **datacenter**          | [**DatacenterProperties**](https://docs.ionos.com/sections-test/python-sdk/cloud-api-python-sdk/models/datacenterproperties) | The properties of the data center to be updated.                                                                                                                                                                                                                                                                                                                                                                                         |                                |
| **pretty**              | **bool**                                                                                                                     | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional] \[default to True] |
| **depth**               | **int**                                                                                                                      | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional] \[default to 0]    |
| **x\_contract\_number** | **int**                                                                                                                      | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                    |

#### Return type

[**Datacenter**](https://docs.ionos.com/sections-test/python-sdk/cloud-api-python-sdk/models/datacenter)

#### Authorization

Basic Authentication, Token Authentication

#### HTTP request headers

* **Content-Type**: application/json
* **Accept**: application/json

## **datacenters\_post**

> Datacenter datacenters\_post(datacenter, pretty=pretty, depth=depth, x\_contract\_number=x\_contract\_number)

Create a Data Center

Creates new data centers, and data centers that already contain elements, such as servers and storage volumes. Virtual data centers are the foundation of the platform; they act as logical containers for all other objects you create, such as servers and storage volumes. You can provision as many data centers as needed. Data centers have their own private networks and are logically segmented from each other to create isolation.

#### Example

```python
from __future__ import print_function
import time
import ionoscloud
from ionoscloud.rest import ApiException

# Defining the host is optional and defaults to https://api.ionos.com/cloudapi/v6
configuration = ionoscloud.Configuration(
    host = 'https://api.ionos.com/cloudapi/v6',
)

# Example of configuring HTTP Basic Authorization
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

with ionoscloud.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = ionoscloud.DataCentersApi(api_client)
    datacenter = ionoscloud.Datacenter() # Datacenter | The data center to create.
    try:
        # Create a Data Center
        api_response = api_instance.datacenters_post(datacenter)
        print(api_response)
    except ApiException as e:
        print('Exception when calling DataCentersApi.datacenters_post: %s\n' % e)
```

#### Parameters

| Name                    | Type                                                                                                     | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                          |
| ----------------------- | -------------------------------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------ |
| **datacenter**          | [**Datacenter**](https://docs.ionos.com/sections-test/python-sdk/cloud-api-python-sdk/models/datacenter) | The data center to create.                                                                                                                                                                                                                                                                                                                                                                                                               |                                |
| **pretty**              | **bool**                                                                                                 | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional] \[default to True] |
| **depth**               | **int**                                                                                                  | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional] \[default to 0]    |
| **x\_contract\_number** | **int**                                                                                                  | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                    |

#### Return type

[**Datacenter**](https://docs.ionos.com/sections-test/python-sdk/cloud-api-python-sdk/models/datacenter)

#### Authorization

Basic Authentication, Token Authentication

#### HTTP request headers

* **Content-Type**: application/json
* **Accept**: application/json

## **datacenters\_put**

> Datacenter datacenters\_put(datacenter\_id, datacenter, pretty=pretty, depth=depth, x\_contract\_number=x\_contract\_number)

Modify a Data Center by ID

Modifies the properties of the specified data center, rename it, or change the description.

#### Example

```python
from __future__ import print_function
import time
import ionoscloud
from ionoscloud.rest import ApiException

# Defining the host is optional and defaults to https://api.ionos.com/cloudapi/v6
configuration = ionoscloud.Configuration(
    host = 'https://api.ionos.com/cloudapi/v6',
)

# Example of configuring HTTP Basic Authorization
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

with ionoscloud.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = ionoscloud.DataCentersApi(api_client)
    datacenter_id = 'datacenter_id_example' # str | The unique ID of the data center.
    datacenter = ionoscloud.Datacenter() # Datacenter | The modified data center.
    try:
        # Modify a Data Center by ID
        api_response = api_instance.datacenters_put(datacenter_id, datacenter)
        print(api_response)
    except ApiException as e:
        print('Exception when calling DataCentersApi.datacenters_put: %s\n' % e)
```

#### Parameters

| Name                    | Type                                                                                                     | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                          |
| ----------------------- | -------------------------------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------ |
| **datacenter\_id**      | **str**                                                                                                  | The unique ID of the data center.                                                                                                                                                                                                                                                                                                                                                                                                        |                                |
| **datacenter**          | [**Datacenter**](https://docs.ionos.com/sections-test/python-sdk/cloud-api-python-sdk/models/datacenter) | The modified data center.                                                                                                                                                                                                                                                                                                                                                                                                                |                                |
| **pretty**              | **bool**                                                                                                 | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional] \[default to True] |
| **depth**               | **int**                                                                                                  | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional] \[default to 0]    |
| **x\_contract\_number** | **int**                                                                                                  | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                    |

#### Return type

[**Datacenter**](https://docs.ionos.com/sections-test/python-sdk/cloud-api-python-sdk/models/datacenter)

#### Authorization

Basic Authentication, Token Authentication

#### HTTP request headers

* **Content-Type**: application/json
* **Accept**: application/json
